package com.kalyshev.yan.computer.model;

import com.kalyshev.yan.cabinet.model.Cabinet;
import com.kalyshev.yan.monitor.model.Monitor;

import javax.persistence.*;
import java.util.Objects;

@Entity
@Table(name = "computer")
public class Computer {
    @Id
    @GeneratedValue
    private Long id;
    private String modelName;
    private String serialNum;
    @ManyToOne( cascade = {CascadeType.MERGE}, fetch = FetchType.EAGER)
    @JoinColumn(name = "cabinet", nullable = true)
    private Cabinet cabinet;
    @OneToOne(cascade = {CascadeType.MERGE})
    @JoinColumn(name = "monitor_id")
    private Monitor monitor;

    public Computer() {
    }
    public Computer(String modelName, String serialNum) {
        this.modelName = modelName;
        this.serialNum = serialNum;
    }

    public Long getId() {
        return id;
    }
    public String getModelName() {
        return modelName;
    }
    public void setModelName(String modelName) {
        this.modelName = modelName;
    }
    public String getSerialNum() {
        return serialNum;
    }
    public void setSerialNum(String serialNum) { this.serialNum = serialNum; }
    public Cabinet getCabinet() {
        return cabinet;
    }
    public void setCabinet(Cabinet cabinet) { this.cabinet = cabinet; }

    public Monitor getMonitor() {
        return monitor;
    }
    public void setMonitor(Monitor monitor) {
        this.monitor = monitor;
    }
    public Monitor removeMonitor() {
        Monitor temp = this.monitor;
        this.monitor = null;
        return temp;
    }
    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (!(o instanceof Computer))
            return false;
        Computer computer = (Computer) o;
        return Objects.equals(id, computer.id) && Objects.equals(this.modelName, computer.modelName) && Objects.equals(this.monitor, computer.monitor) && Objects.equals(this.cabinet, computer.cabinet);
    }
    @Override
    public int hashCode() {
        return Objects.hash(id);
    }
    @Override
    public String toString() {
        return "Computer{" +
                "id=" + id +
                ", modelName='" + modelName + '\'' +
                ", serialNum='" + serialNum + '\'' +
                '}';
    }
}
