package com.kalyshev.yan.user.controller;

import com.kalyshev.yan.user.service.UserService;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.validation.Valid;

@Controller
@RequestMapping(UserSignupController.SIGNUP_URL)
public class UserSignupController {
    public static final String SIGNUP_URL = "/signup";
    private final UserService userService;
    public UserSignupController(UserService userService) {
        this.userService = userService;
    }
    @PostMapping
    public UserDto signup(@RequestBody @Valid UserSignupDto userSignupDto) {
        return new UserDto(userService.createUser(
            userSignupDto.getLogin(), userSignupDto.getPassword(), userSignupDto.getPasswordConfirm()));
    }
}